﻿Imports System.IO

Public Class Voltagegen
    Dim eEvent As String
    Dim tMessage As String
    Dim PortState As Boolean
    Dim lVoltageSettingValue As Long
    Dim tVoltgteSettingValue As String
    Shared fLog As IO.StreamWriter

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        SerialPort1.Close()
        fLog.Flush()
        fLog.Close()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lVoltageSettingValue = 9900000
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBox1.Items.Add(sp)
        Next
        PortState = False
        ComboBox1.SelectedIndex = 0
        'SerialPort1.Open()
        'SerialPort1.DtrEnable = False

        SmLength.Items.Add("4 点平滑滤波")
        SmLength.Items.Add("8 点平滑滤波")
        SmLength.Items.Add("16 点平滑滤波")
        SmLength.Items.Add("32 点平滑滤波")
        SmLength.Items.Add("64 点平滑滤波")
        SmLength.SelectedIndex = 2

        fLog = IO.File.AppendText(Application.StartupPath & "\Record.txt")
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If PortState = False Then
            SerialPort1.PortName = ComboBox1.SelectedItem
            Label1.Text = "当前连接端口：" & ComboBox1.SelectedItem
            SerialPort1.Open()
            Button1.Text = "断开(&D)"
            PortState = True
            CommRTSLab.Text = SerialPort1.RtsEnable
            CommDTRLab.Text = SerialPort1.DtrEnable
        Else
            SerialPort1.Close()
            Button1.Text = "连接(&C)"
            PortState = False
            Label1.Text = "尚未连接"
        End If
    End Sub

    Private Sub ButtSed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtSed.Click
        SerialPort1.WriteLine(Ctrlcmd.Text & vbCrLf)
    End Sub

    Private Sub ReceiveUart(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim dReback As Double = 0, dTemperature As Double = 0, dError As Double = 0
        ' MsgBox(Mid(tMessage, InStr(tMessage, "#CSYN=$") + 8, 13))
        'dReback = CDbl(Mid(tMessage, InStr(tMessage, "#CSYN=$") + 8, 13))
        'dError = CDbl(Mid(tMessage, InStr(tMessage, "#CERR=$") + 8, 13))
        'dTemperature = CDbl(Mid(tMessage, InStr(tMessage, "#TEMP=$") + 8, 13))
        'RebackLab.Text = "回读值：" & FormatNumber(dReback, 6) & " VDC；设置误差：" & FormatNumber(dError, 1) & " uV；当前温度：" & FormatNumber(dTemperature, 1) & " 摄氏度。"

        Rxinfo.AppendText(tMessage & vbCrLf)
        Rxinfo.ScrollToCaret()
        fLog.WriteLine(Now & " " & tMessage)
        fLog.Flush()
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        'Dim tRC() As String, dResult As Double
        tMessage = Trim(SerialPort1.ReadLine())
        Me.Invoke(New EventHandler(AddressOf ReceiveUart))
    End Sub

    Private Sub CommDTR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommDTR.Click
        SerialPort1.DtrEnable = Not SerialPort1.DtrEnable
        CommDTRLab.Text = SerialPort1.DtrEnable
    End Sub

    Private Sub CommRTS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommRTS.Click
        SerialPort1.RtsEnable = Not SerialPort1.RtsEnable
        CommRTSLab.Text = SerialPort1.RtsEnable
    End Sub

    Private Sub nStvSlah_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nStvSlah.ValueChanged
        If nStvMaster.Value = 10 Then nStvSlah.Maximum = 10 Else nStvSlah.Maximum = 999
        lVoltageSettingValue = CLng(nStvMaster.Value) * 1000000 + CLng(nStvSlah.Value) * 1000 + CLng(nStvSlal.Value)
        tVoltgteSettingValue = Replace(Format(lVoltageSettingValue, "00,000,000"), ",", ".", 1, 1)
        lbVoltSetting.Text = "设置值：" & tVoltgteSettingValue
    End Sub

    Private Sub nStvMaster_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nStvMaster.ValueChanged
        If nStvMaster.Value = 10 Then nStvSlah.Maximum = 10 Else nStvSlah.Maximum = 999
        lVoltageSettingValue = CLng(nStvMaster.Value) * 1000000 + CLng(nStvSlah.Value) * 1000 + CLng(nStvSlal.Value)
        tVoltgteSettingValue = Replace(Format(lVoltageSettingValue, "00,000,000"), ",", ".", 1, 1)
        lbVoltSetting.Text = "设置值：" & tVoltgteSettingValue
    End Sub

    Private Sub nStvSlal_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nStvSlal.ValueChanged
        lVoltageSettingValue = CLng(nStvMaster.Value) * 1000000 + CLng(nStvSlah.Value) * 1000 + CLng(nStvSlal.Value)
        tVoltgteSettingValue = Replace(Format(lVoltageSettingValue, "00,000,000"), ",", ".", 1, 1)
        lbVoltSetting.Text = "设置值：" & tVoltgteSettingValue
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        lVoltageSettingValue = CLng(nStvMaster.Value) * 1000000 + CLng(nStvSlah.Value) * 1000 + CLng(nStvSlal.Value)
        tVoltgteSettingValue = Format(lVoltageSettingValue, "00000000")
        tVoltgteSettingValue = "STV" & tVoltgteSettingValue & "0"
        'MsgBox(tVoltgteSettingValue)
        SerialPort1.WriteLine(tVoltgteSettingValue & vbCrLf)
        lbVoltSettbef.Text = lbVoltSetting.Text
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim tSettcmd As String = "STSabb00dd0x"
        Dim ttHreshold As String = ""

        If Loopclose.Checked Then
            tSettcmd = Replace(tSettcmd, "a", "1")
        Else
            tSettcmd = Replace(tSettcmd, "a", "0")
        End If

        Select Case SmLength.SelectedIndex
            Case 0 : tSettcmd = Replace(tSettcmd, "bb", "04")
            Case 1 : tSettcmd = Replace(tSettcmd, "bb", "08")
            Case 2 : tSettcmd = Replace(tSettcmd, "bb", "16")
            Case 3 : tSettcmd = Replace(tSettcmd, "bb", "32")
            Case 4 : tSettcmd = Replace(tSettcmd, "bb", "64")
        End Select
        ttHreshold = tHreshold.Text
        If Math.Abs(CInt(ttHreshold)) < 10 Then ttHreshold = "0" & Trim(CStr(Math.Abs(CInt(ttHreshold)))) Else ttHreshold = Trim(CStr(Math.Abs(CInt(ttHreshold))))
        tSettcmd = Replace(tSettcmd, "dd", ttHreshold)
        'MsgBox(tSettcmd)
        SerialPort1.WriteLine(tSettcmd & vbCrLf)
        'If Loopclose.Checked Then
        'SerialPort1.WriteLine("STS10000000x" & vbCrLf)
        'Else
        'SerialPort1.WriteLine("STS00000000x" & vbCrLf)
        'End If
    End Sub

    Private Sub Buttrun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Buttrun.Click
        If Buttrun.Text = "Stop" Then
            SerialPort1.WriteLine("STSx00000000" & vbCrLf)
            Buttrun.Text = "Run"
        Else
            SerialPort1.WriteLine("STSx00000001" & vbCrLf)
            Buttrun.Text = "Stop"
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        SerialPort1.WriteLine("STSx0000000x" & vbCrLf)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        SerialPort1.WriteLine("STSx0000001x" & vbCrLf)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        SerialPort1.WriteLine("STSx0000002x" & vbCrLf)
    End Sub

    Private Sub bt_SetPwm_Click(sender As Object, e As EventArgs) Handles bt_SetPwm.Click
        Dim tChannel As String = "0"

        If rb_Pwmaster.Checked = True Then
            lVoltageSettingValue = CLng(nb_PAMSB.Value) * 10000 + CLng(nb_PALSB.Value)
            tChannel = "1"
        Else
            lVoltageSettingValue = CLng(nb_PBMSB.Value) * 10000 + CLng(nb_PBLSB.Value)
            tChannel = "2"
        End If
        tVoltgteSettingValue = Format(lVoltageSettingValue, "00000000")
        tVoltgteSettingValue = "PWM" & tVoltgteSettingValue & tChannel
        'MsgBox(tVoltgteSettingValue)
        SerialPort1.WriteLine(tVoltgteSettingValue & vbCrLf)
    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        SerialPort1.WriteLine("abc" & vbCrLf & Chr(0))
    End Sub

    Private Sub SmLength_SelectedIndexChanged(sender As Object, e As EventArgs) Handles SmLength.SelectedIndexChanged

    End Sub
End Class

